default:
  image: php:7.4-apache
  services:
  - mysql:latest

cache:
  paths:
    - vendor/

stages:
  - TestUnitaire
  - deployprod
  - deploystaging

testEntity:
    stage: TestUnitaire
    script:
    - apt update -y
    - pecl install xdebug
    - docker-php-ext-enable xdebug
    - apt install -y libzip-dev zip
    - docker-php-ext-install pdo pdo_mysql zip
    - curl -sS https://getcomposer.org/installer | php
    - mv composer.phar /usr/local/bin/composer
    - php bin/phpunit tests/Entity/

prod:
  type: deployprod
  image: ruby:latest
  variables:
    DATABASE_URL: $DATABASE_URL
    MYSQL_ROOT_PASSWORD: $MYSQL_PASSWORD
    MYSQL_ALLOW_EMPTY_PASSWORD: $MYSQL_PASSWORD
    MYSQL_RANDOM_ROOT_PASSWORD: $MYSQL_PASSWORD
  script:
  - apt-get update -qy
  - apt-get install -y ruby-dev
  - gem install dpl
  - dpl --provider=heroku --app=$HEROKU_APP --api-key=$HEROKU_API_KEY
  only:
    - merge_requests
    - master

staging:
  type: deploystaging
  image: ruby:latest
  variables:
    HEROKU_APPSTAGING : i2i-staging
    HEROKU_API_KEY: 1dfc2bf1-0ee5-49ff-8994-aaf67026b32a
    DATABASE_URL: $DATABASE_URL
    MYSQL_ROOT_PASSWORD: $MYSQL_PASSWORD
    MYSQL_ALLOW_EMPTY_PASSWORD: $MYSQL_PASSWORD
    MYSQL_RANDOM_ROOT_PASSWORD: $MYSQL_PASSWORD
  script:
  - apt-get update -qy
  - apt-get install -y ruby-dev
  - gem install dpl
  - dpl --provider=heroku --app=$HEROKU_APPSTAGING --api-key=$HEROKU_API_KEY
  only:
    - staging